package dev.shadowsoffire.apotheosis.util;

import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.world.item.ItemStack;
import java.util.Collection;
import net.minecraft.network.chat.FormattedText;
import java.util.ArrayList;
import net.minecraft.client.gui.Font;
import java.util.stream.Stream;
import java.util.Comparator;
import java.util.function.Function;
import java.util.Objects;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.client.gui.GuiGraphics;

public interface DrawsOnLeft
{
    default void drawOnLeft(final GuiGraphics gfx, final List<Component> list, final int y) {
        if (list.isEmpty()) {
            return;
        }
        final int n = this.ths().getGuiLeft() - 16;
        final Stream<Object> stream = list.stream();
        final Font f_96547_ = this.ths().f_96547_;
        Objects.requireNonNull(f_96547_);
        int xPos = n - stream.map((Function<? super Object, ?>)f_96547_::m_92852_).max((Comparator<? super Integer>)Integer::compare).get();
        int maxWidth = 9999;
        if (xPos < 0) {
            maxWidth = this.ths().getGuiLeft() - 6;
            xPos = -8;
        }
        this.drawOnLeft(gfx, list, y, maxWidth);
    }
    
    default void drawOnLeft(final GuiGraphics gfx, final List<Component> list, final int y, final int maxWidth) {
        if (list.isEmpty()) {
            return;
        }
        final List<FormattedText> split = new ArrayList<FormattedText>();
        list.forEach(comp -> split.addAll(this.ths().f_96547_.m_92865_().m_92414_((FormattedText)comp, maxWidth, comp.m_7383_())));
        final int n = this.ths().getGuiLeft() - 16;
        final Stream<Object> stream = split.stream();
        final Font f_96547_ = this.ths().f_96547_;
        Objects.requireNonNull(f_96547_);
        final int xPos = n - stream.map((Function<? super Object, ?>)f_96547_::m_92852_).max((Comparator<? super Integer>)Integer::compare).get();
        gfx.renderComponentTooltip(this.ths().f_96547_, (List)split, xPos, y, ItemStack.f_41583_);
    }
    
    default AbstractContainerScreen<?> ths() {
        return (AbstractContainerScreen<?>)this;
    }
    
    default void draw(final AbstractContainerScreen<?> screen, final GuiGraphics gfx, final List<Component> list, final int y) {
        ((DrawsOnLeft)screen).drawOnLeft(gfx, list, y);
    }
}
